#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    int a[n+1];
    scanf("%d",&n);
   int mop[n+1]={0};
    for(int i=1;i<=n;i++)
    {
       scanf("%d",&a[i]);
       if(i>1&&a[i]<a[i-1])mop[i]=mop[i-1]+1;
       else mop[i]=mop[i-1];
    }
    int q;
    int l;
    int r;
    scanf("%d",&q);
    for(int i=1;i<=q;i++)
    {
        scanf("%d",&l);
        scanf("%d",&r);
        if(mop[r]-mop[l]>2)
        {
            printf("NE\n");
        }
        else if (mop[r]-mop[l]==0)
        {
            printf("DA\n");
        }
        else
        {
        int d=r-l+2;
        int noviniz[d];
        for(int j=1;j<d;j++)
        {
            noviniz[j]=a[l+j-1];
        }
        bool moze =true;
        int br=0;
        for(int i=2;i<d;i++)
        {
            if(noviniz[i]<noviniz[i-1])
            {
                br++;
                if(!(noviniz[i]>=noviniz[i-2])&&!(noviniz[i+1]>=noviniz[i-1])&&!(i==2)&&!(i==d-1))
                {
                    moze=false;
                    break;
                }
            }
            if(br>=2)
            {
                moze=false;break;
            }
        }
        if(moze)printf("DA\n");
        else printf("NE\n");
        }
    }
    return 0;
}